GNU bug report logs - #3625
save-some-buffers won't buzz off and let me just visit a file

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: jidanni@HIDDEN; Keywords: fixed; merged with #10229, #24174, #42829; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Forcibly Merged 3625 10229 24174 42829. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
bug archived. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.
bug marked as fixed in version 27.1, send any further explanations to 3625 <at> debbugs.gnu.org and jidanni@HIDDEN Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 3625 <at> debbugs.gnu.org:


Received: (at 3625) by debbugs.gnu.org; 13 Oct 2019 19:41:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 13 15:41:49 2019
Received: from localhost ([127.0.0.1]:37054 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iJjkT-0002L0-IE
	for submit <at> debbugs.gnu.org; Sun, 13 Oct 2019 15:41:49 -0400
Received: from quimby.gnus.org ([80.91.231.51]:37096)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iJjkS-0002Ko-6u
 for 3625 <at> debbugs.gnu.org; Sun, 13 Oct 2019 15:41:48 -0400
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <larsi@HIDDEN>)
 id 1iJjkM-0004dn-Tk; Sun, 13 Oct 2019 21:41:45 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: jidanni@HIDDEN
Subject: Re: bug#3625: save-some-buffers won't buzz off and let me just
 visit a file
References: <87r5xfzi1j.fsf@HIDDEN>
Date: Sun, 13 Oct 2019 21:41:42 +0200
In-Reply-To: <87r5xfzi1j.fsf@HIDDEN> (jidanni@HIDDEN's message of
 "Sat, 20 Jun 2009 11:43:36 +0800")
Message-ID: <875zksa0w9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: jidanni@HIDDEN writes: > C-x s runs the command
 save-some-buffers, 
 > which will ask > Type SPC or `y' to save the current buffer; > DEL or `n'
 to skip the current buffer; > RET or `q' to give up on the save (skip all
 remain [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 3625
Cc: 3625 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

jidanni@HIDDEN writes:

> C-x s runs the command save-some-buffers,
> which will ask
>   Type SPC or `y' to save the current buffer;
>   DEL or `n' to skip the current buffer;
>   RET or `q' to give up on the save (skip all remaining buffers);
>   C-g to quit (cancel the whole command);
>   ! to save all remaining buffers;
>   C-r to view this buffer;
>   d to view changes in this buffer;
>   or . (period) to save the current buffer and exit.
> But nowhere in that list is there a choice to just let you visit that
> buffer. E.g.,
>   C-r to view this buffer;
> still "waits out there in the parking lot (minibuffer) with the engine
> running, waiting for you to come back out. He just won't buzz-off."

That's a good idea -- exiting the query and popping to the buffer being
asked about is a pretty natural thing to do.

So I've now added it to Emacs 27, but it was surprisingly awkward to do,
based on how the actions are defined (a defvarred alist), what they can
return (just "don't do this" and "do this"), and the fact that
`save-some-buffers' is wrapped in a `save-window-excursion' that I think
is best left alone.

But I think I successfully hacked it together by mixing some dynamic
binding with some lexical binding in a kinda messy way.  If somebody has
a better idea how to do this that doesn't go through three indirections:
please be my guest.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#3625; Package emacs. Full text available.
Forcibly Merged 3625 10229 24174. Request was from npostavs@HIDDEN to control <at> debbugs.gnu.org. Full text available.
Forcibly Merged 3625 10229. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Severity set to 'wishlist' from 'normal' Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 3625@HIDDEN:


Received: (at 3625) by emacsbugs.donarmstrong.com; 20 Jun 2009 19:56:26 +0000
From jidanni@HIDDEN Sat Jun 20 12:56:26 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-2.7 required=4.0 tests=AWL,HAS_BUG_NUMBER,
	SARE_RECV_SPAM_DOMN0b autolearn=ham version=3.2.5-bugs.debian.org_2005_01_02
Received: from homiemail-a1.g.dreamhost.com (caiajhbdcbef.dreamhost.com [208.97.132.145])
	by rzlab.ucr.edu (8.14.3/8.14.3/Debian-5) with ESMTP id n5KJuMnT021609
	for <3625@HIDDEN>; Sat, 20 Jun 2009 12:56:23 -0700
Received: from jidanni.org (122-127-33-253.dynamic.hinet.net [122.127.33.253])
	(using TLSv1 with cipher AES256-SHA (256/256 bits))
	(No client certificate requested)
	by homiemail-a1.g.dreamhost.com (Postfix) with ESMTP id DD717119E07;
	Sat, 20 Jun 2009 12:56:21 -0700 (PDT)
From: jidanni@HIDDEN
To: svenjoac@HIDDEN
Cc: 3625 <at> debbugs.gnu.org
Subject: Re: bug#3625: save-some-buffers won't buzz off and let me just visit a file
References: <87eitfpa4a.fsf@HIDDEN>
Date: Sun, 21 Jun 2009 03:56:18 +0800
Message-ID: <87tz2ad6hp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit

SJ> This was done on purpose because somebody had complained about the
SJ> difficulties of recursive editing which is probably the only feasible
SJ> way to visit the buffer in this situation.  See bug #381¹.
SJ> ¹ http://debbugs.gnu.org/381

I see what I want then is the same as what I want now, an additional:

g: never mind saving anymore files, just let me visit that buffer now,
and don't bother waiting for me.

There must be some lisp way of doing that other than something like
system("exec emacsclient -n that_file&")?

We don't need save-some-buffers to do anything more at this point other
than call switch-to-buffer that_files_buffer, and then that's the end of
switch-to-buffer

OK, maybe what is making this impossible is
save-some-buffers-action-alist. But this is getting over my head.



Acknowledgement sent to jidanni@HIDDEN:
Extra info received and forwarded to list. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Information forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3625; Package emacs. Full text available.

Message received at 3625@HIDDEN:


Received: (at 3625) by emacsbugs.donarmstrong.com; 20 Jun 2009 08:45:08 +0000
From svenjoac@HIDDEN Sat Jun 20 01:45:07 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-4.1 required=4.0 tests=AWL,HAS_BUG_NUMBER
	autolearn=ham version=3.2.5-bugs.debian.org_2005_01_02
Received: from mail.gmx.net (mail.gmx.net [213.165.64.20])
	by rzlab.ucr.edu (8.14.3/8.14.3/Debian-5) with SMTP id n5K8j0kD002352
	for <3625@HIDDEN>; Sat, 20 Jun 2009 01:45:02 -0700
Received: (qmail invoked by alias); 20 Jun 2009 08:44:54 -0000
Received: from p548664E7.dip.t-dialin.net (EHLO turtle.gmx.de) [84.134.100.231]
  by mail.gmx.net (mp063) with SMTP; 20 Jun 2009 10:44:54 +0200
X-Authenticated: #28250155
X-Provags-ID: V01U2FsdGVkX1/uwLoKncPuiNhgZ8KGc6jJDi3uoMEu/MWzTcePho
	X06ylLIKjXAI3w
Received: by turtle.gmx.de (Postfix, from userid 1000)
	id AE197354A2; Sat, 20 Jun 2009 10:44:53 +0200 (CEST)
From: Sven Joachim <svenjoac@HIDDEN>
To: jidanni@HIDDEN
Cc: 3625 <at> debbugs.gnu.org
Subject: Re: bug#3625: save-some-buffers won't buzz off and let me just visit a file
References: <87r5xfzi1j.fsf@HIDDEN>
Date: Sat, 20 Jun 2009 10:44:53 +0200
In-Reply-To: <87r5xfzi1j.fsf@HIDDEN> (jidanni@HIDDEN's message of
	"Sat, 20 Jun 2009 11:43:36 +0800")
Message-ID: <87eitfpa4a.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/23.0.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.57

On 2009-06-20 05:43 +0200, jidanni@HIDDEN wrote:

> C-x s runs the command save-some-buffers,
> which will ask
>   Type SPC or `y' to save the current buffer;
>   DEL or `n' to skip the current buffer;
>   RET or `q' to give up on the save (skip all remaining buffers);
>   C-g to quit (cancel the whole command);
>   ! to save all remaining buffers;
>   C-r to view this buffer;
>   d to view changes in this buffer;
>   or . (period) to save the current buffer and exit.
> But nowhere in that list is there a choice to just let you visit that
> buffer. E.g.,
>   C-r to view this buffer;
> still "waits out there in the parking lot (minibuffer) with the engine
> running, waiting for you to come back out. He just won't buzz-off."

This was done on purpose because somebody had complained about the
difficulties of recursive editing which is probably the only feasible
way to visit the buffer in this situation.  See bug #381.

Sven


 http://debbugs.gnu.org/381



Acknowledgement sent to Sven Joachim <svenjoac@HIDDEN>:
Extra info received and forwarded to list. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Information forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3625; Package emacs. Full text available.

Message received at submit@HIDDEN:


Received: (at submit) by emacsbugs.donarmstrong.com; 20 Jun 2009 03:43:53 +0000
From jidanni@HIDDEN Fri Jun 19 20:43:53 2009
X-Spam-Checker-Version: SpamAssassin 3.2.5-bugs.debian.org_2005_01_02
	(2008-06-10) on rzlab.ucr.edu
X-Spam-Level: 
X-Spam-Bayes: score:0.5 Bayes not run. spammytokens:Tokens not available.
	hammytokens:Tokens not available.
X-Spam-Status: No, score=-1.2 required=4.0 tests=AWL,SARE_RECV_SPAM_DOMN0b
	autolearn=no version=3.2.5-bugs.debian.org_2005_01_02
Received: from lists.gnu.org (lists.gnu.org [199.232.76.165])
	by rzlab.ucr.edu (8.14.3/8.14.3/Debian-5) with ESMTP id n5K3hm9a018860
	for <submit@HIDDEN>; Fri, 19 Jun 2009 20:43:50 -0700
Received: from mailman by lists.gnu.org with tmda-scanned (Exim 4.43)
	id 1MHrUa-0002s9-Jg
	for bug-gnu-emacs@HIDDEN; Fri, 19 Jun 2009 23:43:48 -0400
Received: from exim by lists.gnu.org with spam-scanned (Exim 4.43)
	id 1MHrUV-0002lU-JZ
	for bug-gnu-emacs@HIDDEN; Fri, 19 Jun 2009 23:43:47 -0400
Received: from [199.232.76.173] (port=55485 helo=monty-python.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43)
	id 1MHrUV-0002lM-DX
	for bug-gnu-emacs@HIDDEN; Fri, 19 Jun 2009 23:43:43 -0400
Received: from caiajhbdcbhh.dreamhost.com ([208.97.132.177]:49414 helo=homiemail-a6.g.dreamhost.com)
	by monty-python.gnu.org with esmtp (Exim 4.60)
	(envelope-from <jidanni@HIDDEN>)
	id 1MHrUV-00076m-0z
	for bug-gnu-emacs@HIDDEN; Fri, 19 Jun 2009 23:43:43 -0400
Received: from jidanni.org (122-127-32-244.dynamic.hinet.net [122.127.32.244])
	(using TLSv1 with cipher AES256-SHA (256/256 bits))
	(No client certificate requested)
	by homiemail-a6.g.dreamhost.com (Postfix) with ESMTP id CF1D614252
	for <bug-gnu-emacs@HIDDEN>; Fri, 19 Jun 2009 20:43:39 -0700 (PDT)
From: jidanni@HIDDEN
To: bug-gnu-emacs@HIDDEN
Subject: save-some-buffers won't buzz off and let me just visit a file
Date: Sat, 20 Jun 2009 11:43:36 +0800
Message-ID: <87r5xfzi1j.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-detected-operating-system: by monty-python.gnu.org: GNU/Linux 2.6 (newer, 1)

C-x s runs the command save-some-buffers,
which will ask
  Type SPC or `y' to save the current buffer;
  DEL or `n' to skip the current buffer;
  RET or `q' to give up on the save (skip all remaining buffers);
  C-g to quit (cancel the whole command);
  ! to save all remaining buffers;
  C-r to view this buffer;
  d to view changes in this buffer;
  or . (period) to save the current buffer and exit.
But nowhere in that list is there a choice to just let you visit that
buffer. E.g.,
  C-r to view this buffer;
still "waits out there in the parking lot (minibuffer) with the engine
running, waiting for you to come back out. He just won't buzz-off."

In GNU Emacs 23.0.94.1




Acknowledgement sent to jidanni@HIDDEN:
New bug report received and forwarded. Copy sent to Emacs Bugs <bug-gnu-emacs@HIDDEN>. Full text available.
Report forwarded to bug-submit-list@HIDDEN, Emacs Bugs <bug-gnu-emacs@HIDDEN>:
bug#3625; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 12 Aug 2020 15:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.